/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */

#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#include <mach/boolean.h>
#include <mach/machine/eflags.h>
#include <mach/machine/far_ptr.h>
#include <mach/machine/pio.h>
#include <mach/machine/code16.h>
#include <mach/machine/asm.h>

#include "real.h"
#include "debug.h"

static unsigned char old_video_mode;

void save_video_mode()
{
	real_call_data.eax = 0x0f00;
	real_int(0x10, &real_call_data);
	old_video_mode = real_call_data.eax & 0xff;
}

void restore_video_mode()
{
	if (old_video_mode)
	{
		real_call_data.eax = 0x0f00;
		real_int(0x10, &real_call_data);
		if ((real_call_data.eax & 0xff) != old_video_mode)
		{
			real_call_data.eax = old_video_mode;
			real_int(0x10, &real_call_data);
		}
	}
}

void dos_get_int_vec(int vecnum, struct far_pointer_16 *out_vec)
{
	real_call_data.eax = 0x3500 | vecnum;
	real_int(0x21, &real_call_data);
	out_vec->seg = real_call_data.es;
	out_vec->ofs = real_call_data.ebx;
}

void dos_set_int_vec(int vecnum, struct far_pointer_16 *new_vec)
{
	real_call_data.eax = 0x2500 | vecnum;
	real_call_data.ds = new_vec->seg;
	real_call_data.edx = new_vec->ofs;
	real_int(0x21, &real_call_data);
}

