/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */
#ifndef _MOSS_KERNEL_EFS_H
#define _MOSS_KERNEL_EFS_H

#include <sys/types.h>

struct stat;

struct fd_efs
{
	/* EFS entry for this file.  */
	unsigned idx;

	/* Current file pointer in this file.  */
	off_t ofs;
};

void efs_init();
int efs_open(const char *name, int flags, mode_t mode, struct fd_efs *fd);
int efs_close(struct fd_efs *fd);
int efs_read(struct fd_efs *fd, void *buf, size_t size, size_t *actual);
int efs_seek(struct fd_efs *fd, off_t offset, int whence, off_t *newpos);
int efs_fstat(struct fd_efs *fd, struct stat *stat);

#endif _MOSS_KERNEL_EFS_H
