/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */

#include "idt.h"
#include "cpu.h"
#include "debug.h"

extern vm_offset_t real_int_handlers[];

/* Initialize the hardware interrupt vectors in our IDT
   so they point to the proper default handlers
   which reflect interrupts to real mode.  */
void idt_irq_init()
{
	int i;

	assert(irq_master_base + 8 <= IDTSZ);
	assert(irq_slave_base + 8 <= IDTSZ);

	for (i = 0; i < 8; i++)
		fill_idt_gate(&cpu[0], irq_master_base+i,
			      real_int_handlers[i], KERNEL_CS,
			      ACC_PL_K|ACC_INTR_GATE);

	for (i = 0; i < 8; i++)
		fill_idt_gate(&cpu[0], irq_slave_base+i,
			      real_int_handlers[8+i], KERNEL_CS,
			      ACC_PL_K|ACC_INTR_GATE);
}

