/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */

#include <mach/machine/vm_types.h>
#include <mach/machine/vm_param.h>
#include <mach/machine/proc_reg.h>

#include "vm_param.h"
#include "cpu.h"
#include "ldt.h"
#include "raw.h"

extern int raw_syscall_entry();

void
cpu_ldt_init(struct cpu *cpu)
{
	/* Initialize the system call gate.  */
	fill_ldt_gate(cpu, USER_SCALL,
		      (vm_offset_t)&raw_syscall_entry, KERNEL_CS,
		      ACC_PL_U|ACC_CALL_GATE, 0);

	/* Initialize the code and data segment descriptors.  */
	fill_ldt_descriptor(cpu, USER_CS,
			    PROG_MIN_LIN, PROG_MAX_VA-1,
			    ACC_PL_U|ACC_CODE_R, SZ_32);
	fill_ldt_descriptor(cpu, USER_DS,
			    PROG_MIN_LIN, PROG_MAX_VA-1,
			    ACC_PL_U|ACC_DATA_W, SZ_32);

	/* Initialize the fastint code and data segment descriptors.
	   They are the same as the above, but with supervisor privilege.  */
	fill_ldt_descriptor(cpu, FASTINT_CS,
			    PROG_MIN_LIN, PROG_MAX_VA-1,
			    ACC_PL_K|ACC_CODE_R, SZ_32);
	fill_ldt_descriptor(cpu, FASTINT_DS,
			    PROG_MIN_LIN, PROG_MAX_VA-1,
			    ACC_PL_K|ACC_DATA_W, SZ_32);
}

