/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */

#include <mach/machine/seg.h>
#include <mach/machine/eflags.h>
#include <mach/machine/proc_reg.h>

#include "real.h"
#include "i16.h"
#include "i16_dos.h"
#include "idt.h"
#include "ldt.h"
#include "vm_param.h"
#include "prog.h"
#include "debug.h"
#include "trap.h"
#include "i16_switch.h"


extern void raw_real_int(int intnum, struct real_call_data *rcd);

extern void i16_v86_switch_to_real_mode();
extern void i16_v86_switch_to_pmode();

void v86_real_int(int intnum, struct real_call_data *rcd)
{
	do_16bit(
		unsigned int eflags;

		i16_v86_switch_to_real_mode();
		i16_real_int(intnum, rcd);
		i16_v86_switch_to_pmode();
	);
}

void vcpi_start()
{
	extern const struct progvec raw_progvec;

	progvec = &raw_progvec;

	/* Initialize and start the subject program.  */
	prog_start();
}

void raw_start()
{
	/* From now on, handle BIOS/DOS software interrupts
	   by switching to v86 mode instead of to real mode.  */
	if (real_int == raw_real_int)
	{
		real_int = v86_real_int;
		i16_switch_to_real_mode = i16_v86_switch_to_real_mode;
		i16_switch_to_pmode = i16_v86_switch_to_pmode;
	}

	set_cr0(get_cr0() | CR0_TS);

	vcpi_start();
}

