/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */
#ifndef _MOSS_RAW_
#define _MOSS_RAW_

/* This defines the layout of the subject program's virtual address space
   when running in raw mode.  */
#define PROG_MIN_VA	0x00000000
#define PROG_MAX_VA	0x80000000


/* This is where the program is mapped in linear memory.  */
#define PROG_MIN_LIN	0x40000000


void i16_raw_enable_a20();
void i16_raw_disable_a20();

/* Actual functions to use to change A20:
   the XMS versions if available; otherwise the raw versions.  */
extern void (*i16_enable_a20)();
extern void (*i16_disable_a20)();

#endif _MOSS_RAW_
