/*
 * MOSS: DOS extender based on the Flux OS toolkit
 * Copyright (C) 1996-1994 Sleepless Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	Author: Bryan Ford
 */
#ifndef _MOSS_KERNEL_REMOTE_GDB_H_
#define _MOSS_KERNEL_REMOTE_GDB_H_

#include "config.h"

#ifdef ENABLE_REMOTE_GDB

struct trap_state;

extern int rgdb_enable;

extern void rgdb_init();
extern int rgdb_signal(int *inout_sig, struct trap_state *ts);
extern void rgdb_shutdown(int exitcode);

#else /* not ENABLE_REMOTE_GDB */

#define rgdb_enable 0
#define rgdb_init()
#define rgdb_signal(inout_sig, ts) 0
#define rgdb_shutdown(exitcode)

#endif /* not ENABLE_REMOTE_GDB */

#endif /* _MOSS_KERNEL_REMOTE_GDB_H_ */
