/* 
 * Copyright (c) 1996-1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

	.text

	/* Ensure that the denit code gets called on exit.  */
	pushl	$fini
	call	EXT(atexit)
	addl	$4,%esp

	/* Call the init code.  */
	call	init

	/* Call all global constructors.  */
	lea	ctors,%ebx
1:	movl	(%ebx),%eax
	orl	%eax,%eax
	jz	2f
	call	*%eax
	addl	$4,%ebx
	jmp	1b
2:

	.section .init
	.type init,@function
init:

	.section .fini
	.type fini,@function
fini:

	/* Call all global destructors.  */
	pushl	%ebx
	lea	dtors,%ebx
1:	movl	(%ebx),%eax
	orl	%eax,%eax
	jz	2f
	call	*%eax
	addl	$4,%ebx
	jmp	1b
2:	popl	%ebx

	.section .ctors,"a",@progbits
	P2ALIGN(2)
/* DATA(__CTOR_LIST__) */
	.long	-1
ctors:

	.section .dtors,"a",@progbits
	P2ALIGN(2)
/* DATA(__DTOR_LIST__) */
	.long	-1
dtors:

	.text

