/* 
 * Copyright (c) 1996-1994 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

#include <mach/machine/asm.h>

	.text

	/* Magic fastint trampoline code:
	   kernel expects it to be 32 bytes before program's entrypoint.  */
	/* Kernel will fill in the address.  */
	ljmp	$0,$0
	.org	8
	ljmp	$0,$0

	.org	16

	/* Magic signal trampoline code:
	   kernel expects it to be 16 bytes before program's entrypoint.  */
	movl	$-1,%eax
	lcall	$7,$0

	.org	32
ENTRY(_start)

	/* On entry, the stack already contains argc, argv, and envp,
	   all ready for the call to main().  */

	/* Copy the environment pointer to the global environ variable.  */
	movl	8(%esp), %eax
	movl	%eax,EXT(environ)

	/* Include the constructor/destructor initialization code.  */
#include "crti.Sh"

	/* Enter the program.  */
	call	EXT(main)

	/* Exit the program.  */
	pushl	%eax
	jmp	EXT(exit)

